
   switch(in[0]) {
      case 'Z':
         switch(in[1]) {
            case '2':
               switch(in[2]) {
                  case 'S':   	if(pc>1)printf("z2s (Z2S) : Impedance to s11 (memory Z0 or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(mp,"RMZ0"))!=-1) z=mp->e[x].d;
                     err=c_z2s(xp,z,erm); break;
                  case 'L':   	if(pc>1)printf("z2l (Z2L) : Impedance to inductance (memory w) ");
                     x=m_find(m1, "RMW");
                     if(x==-1) { strcpy(erm,"w not specified."); err=1; break; }
                     err=c_z2l(xp,mp->e[x].d,erm); break;
                  case 'C':   	if(pc>1)printf("z2c (Z2C) : Impedance to capacitance (memory w) ");
                     x=m_find(m1, "RMW");
                     if(x==-1) { strcpy(erm,"w not specified. "); err=1; break; }
                     err=c_z2c(xp,mp->e[x].d,erm); break;
                  }  break;
            }  break;
      case 'Y':   	if(pc>1)printf("y^x (Y) : y=y^x, pop stack ");
         err=c_YpX(yp,*xp);s_pop(sp); break;
      case 'X':   	if(pc>1)printf("x^2 (X^2) : x = x^2 ");
         err=c_x2(xp); break;
      case 'W':
         switch(in[1]) {
            case '2':
               switch(in[2]) {
                  case 'V':   	if(pc>1)printf("w2v (W2V) : Watts to voltage (memory R or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;
                     err=c_w2v(xp,z,erm); break;
                  case 'F':   	if(pc>1)printf("w2f (W2F) : Radians to Hertz, x = x/(2pi) ");
                     err=c_w2f(xp); break;
                  case 'D':   	if(pc>1)printf("w2d (W2D) : Watts to dBm, x=10log10(x/0.001) ");
                     err=c_w2d(xp,erm); break;
                  }  break;
            }  break;
      case 'V':
         switch(in[1]) {
            case 'E':   	if(pc>1)printf("ver (VE) : Print program version ");
               {printf("\n\n%s\n\n", ver);
               printf("bcl     %s  %s\n", bver, bdat);
               printf("cfuncs  %s  %s\n", fver, fdat);
               printf("cstack  %s  %s\n", sver, sdat);
               printf("chelp   %s  %s\n", hver, hdat);
               printf("mofunc  %s  %s", mver, mdat); err=0;} break;
            case '2':
               switch(in[2]) {
                  case 'W':   	if(pc>1)printf("v2w (V2W) : Voltage to watts (memory R or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;
                     err=c_v2w(xp,z,erm); break;
                  case 'D':   	if(pc>1)printf("v2d (V2D) : Voltage to dbm (memory R or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;
                     err=c_v2d(xp,z,erm); break;
                  }  break;
            }  break;
      case 'U':   	if(pc>1)printf("u (U) : Undo, recall last stack (doesn't restore memory) ");
         for(x=0; x<sp->len; x++) sp->d[x]=s1u->d[x]; err=0; break;
      case 'T':   	if(pc>1)printf("tan (T) : Tangent, x=tan(x) ");
         err=c_tan(xp,rd,erm); break;
      case 'S':
         switch(in[1]) {
            case 'W':   	if(pc>1)printf("swap (SW) : Swap x and y on stack ");
               err=s_swapxy(s1); break;
            case 'Q':   	if(pc>1)printf("sqrt (SQ) : Square root, x=sqrt(x) ");
               err=c_sqrt(xp); break;
            case 'M':   	if(pc>1)printf("sm (SM) : save to memory, smN where N is an alphanumeric name ");
               x=m_find(mp,in);
               if(x==-1) { strcpy(erm,"Memory full\n"); err=1; }
               else { mp->e[x].d=*xp; err=0; } break;
            case 'I':   	if(pc>1)printf("sin (SI) : Sine, x=sin(x) ");
               err=c_sin(xp, rd); break;
            case 'C':   	if(pc>1)printf("sci (SC) : Print format, toggles between float and scientific format ");
               mode=-mode; err=0; break;
            case '2':
               switch(in[2]) {
                  case 'Z':   	if(pc>1)printf("s2z (S2Z) : s11 to impedance (memory Z0 or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(mp,"RMZ0"))!=-1) z=mp->e[x].d;
                     err=c_s2z(xp,z,erm); break;
                  case 'P':   	if(pc>1)printf("s2p (S2P) : Series impedance to parallel, push, y=Rp, x=jXp ");
                     s_push(sp);err=c_zs2p(yp,xp); break;
                  }  break;
            }  break;
      case 'R':
         switch(in[1]) {
            case 'M':   	if(pc>1)printf("rm (RM) : Recall memory, rmN where N is an alphanumeric name ");
               x=m_find(mp,in);
               if(x==-1)
               {  sprintf(erm," %s not found.", in+2); err=1;
                  if(pc>0)
                  {  printf("\nValid names:\t");
                     for(x=0; x<mp->len; x++) printf("%s\t", mp->e[x].name);
                     printf("\n");
                  }
               }
               else
               {  s_push(sp); *xp=mp->e[x].d;  err=0;}
                break;
            case 'E':
               switch(in[2]) {
                  case 'S':   	if(pc>1)printf("res (RES) : Resonant impedance (memory w) ");
                     x=m_find(m1, "RMW");
                     if(x==-1) {strcpy(erm,"w not specified. "); err=1; break; }
                     err=c_res(xp,mp->e[x].d,erm); break;
                  default :   	if(pc>1)printf("real (RE) : Real part of complex number ");
                     err=c_real(xp); break;
               }  break;
            case '2':   	if(pc>1)printf("r2p (R2P) : Rms to peak, x=x*sqrt(2) ");
               err=c_r2p(xp); break;
            default :   	if(pc>1)printf("r (R) : Radian mode ");
               if(pc>=0)printf(" Radian mode."); rd=1.0; err=0; break;
         }  break;
      case 'Q':   	if(pc>1)printf("q (Q) : Quit ");
         not_done=0; err=0; break;
      case 'P':
         switch(in[1]) {
            case 'U':   	if(pc>1)printf("push (PU) : Push stack ");
               err=s_push(s1); break;
            case 'R':   	if(pc>1)printf("print (PR) : Print stack ");
               printf("\n\n"); err=s_print(s1,mode,fix,rd,erm); break;
            case 'O':   	if(pc>1)printf("pop (PO) : Pop stack ");
               err=s_pop(s1); break;
            case 'I':   	if(pc>1)printf("pi (PI) : Pi, push, enter pi into x ");
               s_push(sp); *xp=cx(acos(-1.0), 0.0); err=0;
               if(in[2]!=0 && in[2]!=' ')
                  { strcpy(in2, in+2); strcpy(in, in2); goto Cmd1; } break;
            case 'A':   	if(pc>1)printf("par (PA) : Parallel impedances, y=1/(1/x+1/y), pop ");
               err=c_zpar(yp,*xp);s_pop(sp); break;
            case '2':   	if(pc>1)printf("p2r (P2R) : Peak to rms, x=x/sqrt(2) ");
               err=c_p2r(xp); break;
            }  break;
      case 'O':   	if(pc>1)printf("oct (O) : Octal format ");
         if(mode>0) mode=8; else mode=-8;
         err=0; break;
      case 'M':
         switch(in[1]) {
            case 'E':   	if(pc>1)printf("mem (ME) : Show memory ");
               err=m_print(m1,mode,fix,rd,erm); break;
            case 'A':   	if(pc>1)printf("mag (MA) : Magnitude, x=mag(x) ");
               err=c_mag(xp); break;
            case '>':   	if(pc>1)printf("m> (M>) : Write memory to a file, m>filename ");
               if( (fyle=fopen(in0+2, "w"))!=NULL)
               {  for(x=0; x<mp->len; x++)
                     fprintf(fyle, "%s %e %e\n",
                        mp->e[x].name, mp->e[x].d.a, mp->e[x].d.b);
                  err=0;
               }
               else { strcpy(erm,"File open error."); err=1; }
               fclose(fyle); break;
            case '<':   	if(pc>1)printf("m< (M<) : Load memory from a file, m<filename ");
               err=0;
               if( (fyle=fopen(in0+2, "r"))!=NULL)
               {  while((y=fscanf(fyle,"%s %lf %lf\n", buf, &a, &b))!=EOF)
                  {  if(buf[0]!=0 && y>1)
                     {  strcpy(buf2, "SM"); strcat(buf2, buf);
                        x=m_find(m1,buf2);
                        mp->e[x].d.a=a; if(y>2) mp->e[x].d.b=b; err=0;
                     }
                     else { sprintf(erm,"\nFile syntax error at: %s", buf); err=1;}
                  }
                  fclose(fyle);
               }
               else { strcpy(erm,"File open error."); err=1; } break;
            }  break;
      case 'L':
         switch(in[1]) {
            case 'O':
               switch(in[2]) {
                  case 'G':   	if(pc>1)printf("log10 (LOG10) : Log base 10, x=log10(x) ");
                     err=c_log10(xp,erm); break;
                  default :   	if(pc>1)printf("log (LO) : Logrithm, y=log(y) base x, pop stack ");
                     err=c_log(yp,*xp,erm);s_pop(sp); break;
               }  break;
            case 'N':   	if(pc>1)printf("ln (LN) : Natural logrithm, x=ln(x) ");
               err=c_ln(xp,erm); break;
            case '2':   	if(pc>1)printf("l2z (L2Z) : Inductance to impedance (memory w) ");
               if((x=m_find(mp,"RMW"))==-1)
               {  strcpy(erm,"No w specified."); err=1; }
               else
                  err=c_l2z(xp,mp->e[x].d,erm); break;
            }  break;
      case 'I':
         switch(in[1]) {
            case 'N':
               switch(in[2]) {
                  case 'V':   	if(pc>1)printf("inv (INV) : Inverse, x=1/x ");
                     err=c_inv(xp,erm); break;
                  default :   	if(pc>1)printf("int (IN) : Integer part of complex number ");
                     err=c_int(xp); break;
               }  break;
            default :   	if(pc>1)printf("imag (I) : Imaginary part of complex number ");
               err=c_imag(xp); break;
         }  break;
      case 'H':
         switch(in[1]) {
            case 'E':   	if(pc>1)printf("hex (HE) : Hexadecimal format ");
               if(mode>0) mode=16; else mode=-16;
               err=0; break;
            default :   	if(pc>1)printf("help (H) : Help ");
               help();err=0; break;
         }  break;
      case 'F':
         switch(in[1]) {
            case 'R':
               switch(in[2]) {
                  case 'A':   	if(pc>1)printf("frac (FRA) : Fractional part of complex number ");
                     err=c_frac(xp); break;
                  default :   	if(pc>1)printf("fr (FR) : frN: set frequency, w=2pi*N, saved in memory w ");
                     if(in[2]==0) { strcpy(erm,"Zero frequency. "); err=1; }
                     else { x=m_find(mp,"SMW");
                     mp->e[x].d = cx(atofM(in0+2)*2*acos(-1), 0.0); err=0;
                     } break;
               }  break;
            case 'I':   	if(pc>1)printf("fix (FI) : Fix print precision, fixN (N=0-15) ");
               a=atof(in+3);
               if(a<0 || a>15) { strcpy(erm, " Fix range 0-15 "); err=1; }
               else { fix=a; err=0; }
               break; break;
            case '2':
               switch(in[2]) {
                  case 'W':   	if(pc>1)printf("f2w (F2W) : Hertz to radians, x=x*2pi ");
                     err=c_f2w(xp); break;
                  case 'C':   	if(pc>1)printf("f2c (F2C) : Farenheit to Celcius, x=(x-32)*5/9 ");
                     err=c_f2c(xp); break;
                  }  break;
            }  break;
      case 'E':   	if(pc>1)printf("exp (E) : x=exp(x) ");
         err=c_exp(xp); break;
      case 'D':
         switch(in[1]) {
            case 'E':   	if(pc>1)printf("dec (DE) : Decimal format ");
               if(mode>0) mode=10; else mode=-10;
               err=0; break;
            case 'B':
               switch(in[2]) {
                  case 'V':   	if(pc>1)printf("dbv (DBV) : y=20*log10(y/x), pop stack ");
                     err=c_db(yp,*xp,erm);c_mult(yp,2.0);s_pop(sp); break;
                  default :   	if(pc>1)printf("db (DB) : dB, y=10*log10(y/x), pop stack ");
                     err=c_db(yp,*xp,erm);s_pop(sp); break;
               }  break;
            case '2':
               switch(in[2]) {
                  case 'W':   	if(pc>1)printf("d2w (D2W) : dBm to watts, x=10^(x/10)*0.001 ");
                     err=c_d2w(xp); break;
                  case 'V':   	if(pc>1)printf("d2v (D2V) : dbm to voltage (memory R or default 50 ohms) ");
                     z=cx(50.0,0.0);
                     if( (x=m_find(m1, "RMR"))!=-1) z=mp->e[x].d;
                     err=c_d2v(xp,z,erm); break;
                  }  break;
            default :   	if(pc>1)printf("d (D) : Degree mode ");
               if(pc>=0)printf(" Degree mode."); rd=180.0/acos(-1.0); err=0; break;
         }  break;
      case 'C':
         switch(in[1]) {
            case 'X':   	if(pc>1)printf("cx (CX) : Clear x ");
               err=s_clearx(s1); break;
            case 'S':   	if(pc>1)printf("cs (CS) : Clear stack ");
               err=s_clear(s1); break;
            case 'O':
               switch(in[2]) {
                  case 'S':   	if(pc>1)printf("cos (COS) : Cosine, x=cos(x) ");
                     err=c_cos(xp, rd); break;
                  default :   	if(pc>1)printf("conj (CO) : Complex conjucate, x=conj(x) ");
                     err=c_conj(xp); break;
               }  break;
            case 'M':   	if(pc>1)printf("cmem (CM) : Clear memory ");
               err=m_clear(m1); break;
            case 'H':   	if(pc>1)printf("chs (CH) : Change sign, x=-x ");
               err=c_chs(xp); break;
            case 'A':   	if(pc>1)printf("ca (CA) : Clear all, clears stack and memory ");
               s_clear(sp); m_clear(mp); err=0; break;
            case '2':
               switch(in[2]) {
                  case 'Z':   	if(pc>1)printf("c2z (C2Z) : Capacitance to impedance (memory w) ");
                     if((x=m_find(mp,"RMW"))==-1)
                     {  strcpy(erm," No w specified."); err=1; }
                     else
                        err=c_c2z(xp,mp->e[x].d,erm); break;
                  case 'F':   	if(pc>1)printf("c2f (C2F) : Celcius to Farenheit, x=x*9/5+32 ");
                     err=c_c2f(xp); break;
                  }  break;
            }  break;
      case 'B':
         switch(in[1]) {
            case 'I':   	if(pc>1)printf("bin (BI) : Binary format ");
               if(mode>0) mode=2; else mode=-2;
               err=0; break;
            default :   	if(pc>1)printf("base (B) : Base for numeric display ");
               for(x=0; x<4 && in[x]>64; x++) ; a=atof(in+x);
               if(a<2 || a>36) { strcpy(erm, " Valid base range 2-36 "); err=1; }
               else { if(mode>0) mode=a; else mode=-a; err=0;} break;
         }  break;
      case '[':   	if(pc>1)printf("[ ([) : Memory shortname, [mem_name ");
         err=0;
         /* look for end of name, non-alphanumeric */
         for(x=0, p=&in[0]+1; *p>47; p++, x++) buf[x]=*p;
         buf[x]=0;
         strcpy(buf2, "RM"); strcat(buf2, buf); x=m_find(m1, buf2);
         if(x==-1)
         {  if(pc>=0) printf("\007Invalid memory location %s\n", buf);
            in[0]=0;
         }
         else
         {  s_push(sp); *xp=mp->e[x].d; 
            strcpy(in, p); if(in[0]!=0) goto Cmd1;
         } break;
      case '?':
         switch(in[1]) {
            case 'F':   	if(pc>1)printf("?F (?F) : Print function list ");
               err=0;help2(); break;
            case '2':   	if(pc>1)printf("?2 (?2) : Verbose help level 2 (command descriptions) ");
               err=0;pc=2; break;
            case '1':   	if(pc>1)printf("?1 (?1) : Verbose help level 1 (shows parsing) ");
               err=0;pc=1; break;
            case '0':   	if(pc>1)printf("?0 (?0) : Verbose help off ");
               err=0;pc=0; break;
            case '-':   	if(pc>1)printf("?- (?-) : Program quiet unless asked to speak ");
               err=0;pc=-1; break;
            default :   	if(pc>1)printf("? (?) : Print help ");
               err=0;help(); break;
         }  break;
      case '<':   	if(pc>1)printf("< (<) : Enter commands from a file, <filename ");
         err=0;
         /* the concatonate don't work. is it just MS? */
         if( (fyle=fopen(in0+1, "r"))!=NULL)
         {  buf[0]=0; x=0; if(pc>=0) printf("\n\n");
            while(fgets(bufin, 1023, fyle)!=NULL)
            {  if(pc>=0) { x++; printf("file line%2d:%s", x, bufin); }
               for(y=0; bufin[y]!=0; y++) if(bufin[y]=='#') bufin[y]=0;
               if(bufin[0]!=0)
               {  bufin[strlen(bufin)-1]=' '; strcat(buf,bufin);
               }
            }
            fclose(fyle);
            if(pc>=0) printf("\n\ncat: %s\n\n", buf);
            if(buf[0]!=0)
            {  strcat(buf, in_m); strcpy(in_m, buf);
            }
          }
          else { strcpy(erm,"File open error."); err=1; } break;
      case '/':   	if(pc>1)printf("/ (/) : y=x/y, pop stack ");
         err=c_div(yp,*xp);s_pop(sp); break;
      case '*':   	if(pc>1)printf("* (*) : y=x*y, pop stack ");
         err=c_mult(yp,*xp);s_pop(sp); break;
   }
