/* chelp.h           help for ccalc.c */



#define hver "v0.02b"

#define hdat "07/18/2003"



void help();



void help(void)

{  char stall[22];



   printf("\n\n%s\n\n", ver);

   printf("The Complex Calculator uses reverse polish notation.\n\n");

   printf("A four level stack is used. The first two levels are x and y.\n");

   printf("Data is entered in level x\n");

   printf("\nNumbers are entered in the form a+jb or r<theta\n");

   printf("Theta can be degrees or radians. ");

   printf("(The program starts in degree mode.)\n");

   printf("The metric suffixes T,G,M,k,h,c,m,u,n,p,f,a are recognized.\n");

   printf("Examples: 4.5-j3, .4<45, 2, j8, -j3E6, 3k, 5m-j2k, j\n\n");

   printf("Real integers can be entered in hexadecimal, octal or binary\n");

   printf("form with the prefixes 0x, 0o or 0b, ex. 0x5a, 0o71, 0b10110");

   printf("\n\nThe command ?f gives a complete list of functions.");

   printf("\n\nHit Return for a partial list of commands.");

   fgets(stall, 20, stdin);



   printf("\nCatagory\tCommand\tShort\tDescription\n\n");

   printf("Stack\t\t<Return>\tPush stack\n");

   printf("Operations\tpop\t\tPop stack\n");

   printf("\t\tcx\t\tClear x\n\t\tcs\t\tClear stack\n");

   printf("\t\tcm\t\tClear memory\n\t\tca\t\tClear all\n");

   printf("\t\tswap\t(sw)\tSwap x and y\n");

   printf("\t\tundo\t(u)\tUndo last single stack operation\n");



   printf("\nFunctions\t");

   printf("+,-,*,/\t\tx=y+x, x=y-x, x=y*x, x=y/x, pop stack\n");

   printf("\t\tsqr\t(sq)\tx = square root of x\n\t\tx^2\t(x)\tx = x^2\n");

   printf("\t\t1/x\t\tx = 1/x\n\t\texp\t(e)\tx = e^x\n");

   printf("\t\t10^x\t(10^)\tx = 10^x\n");

   printf("\t\tln\t\tx = Natural log of x\n");

   printf("\t\tlog\t\tx = Log base 10 of x\n");

   printf("\t\ty^x\t(^, y)\tx = y^x, pop stack\n\t\tchs\t(ch)\tx = -x\n");

   printf("\t\tsin\t(si)\tx = sin(x)\n\t\tcos\t\tx = cos(x)\n");

   printf("\t\ttan\t(t)\tx = tan(x)\n");

   printf("\n");



   printf("\t\tmag\t(ma)\tx = magnitude of x\n");

   printf("\t\treal\t(re)\tx = real part of x\n");

   printf("\t\timag\t(i)\tx = imaginary part of x\n");

   printf("\t\tconj\t(con)\tx = complex conjugate of x\n");

   printf("\n");



   printf("\t\tpar\t(pa)\tx = 1/(1/x + 1/y), pop stack\n");

   printf("\t\tdb\t\tx = 10*log10(y/x), pop stack (real only)\n");

   printf("\t\tdbv\t\tx = 20*log10(y/x), pop stack (real only)\n");

   printf("\t\tf2w\t\tx = Hz to Radians (real only)\n");

   printf("\t\tp2r\t\tx = peak to rms (x=x/sqrt(2))\n");

   printf("\t\tr2p\t\tx = rms to peak (x=x*sqrt(2))\n");

   printf("\t\tw2f\t\tx = Radians to Hz (real only)\n");



   printf("\nHit Return for more."); fgets(stall, 20, stdin);



   printf("\nCatagory\tCommand\tShort\tDescription\n");

   printf("\nMiscellaneous");

   printf("\td\t\tDegree mode\n\t\tr\t\tRadian mode\n");

   printf("\t\tsmN\t\tStore x in memory N (N is an alphanumeric name)\n");

   printf("\t\trmN\t\tPush stack, Recall x from memory N\n");

   printf("\t\tmem\t\tShow memory\n");

   printf("\t\tm<file\t\tRead memory file\n");

   printf("\t\tm>file\t\tWrite memory to file\n");

   printf("\t\tsci\t(sc)\tToggle between normal and scientific format\n");

   printf("\t\tfixN\t\tFix precision in normal format to N digits\n");

   printf("\t\tpi\t\tPush stack, Enter pi into x\n");

   printf("\t\t<filename\tEnter commands from a file (# is comment mark)\n");

   printf("\n");

   printf("\t\t?-\t\tQuiet help level. Speaks only when asked.\n");

   printf("\t\t?N\t\tVerbose help level. 0=off, 1=some, 2=gabby\n");

   printf("\t\t?F\t\tComplete function list\n");

   printf("\t\t? or h\t\tThis help screen\n");

   printf("\t\tquit\t(q)\tEnd program\n");

   printf("\n");

   

   printf("   A command may be entered immediately after a numeric entry.\n");

   printf("   Examples: 4*, 3<45+, 2e, 4sqr, 45sin\n\n");

   printf("   Multiple commands may may be seperated by spaces.\n");

   printf("   Examples: 4 3* 2+ 45sin /, 3x 4x + sqr\n\n"); 

   printf("   The [ character is used as a memory shorthand.\n");

   printf("   [x in the command line will be replaced by the value of memory x.\n");

   printf("   Examples: 10 [freq*, [a [b+\n");

}

