#define bver "v0.02b"
#define bdat "07/21/2003"

void help2();

void help2(void)
{ char buf[100];
  printf("\n  Function Shorthand    Description\n");

printf("  1:     * (*)     	y=x*y, pop stack\n");
printf("  2:     / (/)     	y=x/y, pop stack\n");
printf("  3:     < (<)     	Enter commands from a file, <filename\n");
printf("  4:     ? (?)     	Print help\n");
printf("  5:    ?- (?-)     	Program quiet unless asked to speak\n");
printf("  6:    ?0 (?0)     	Verbose help off\n");
printf("  7:    ?1 (?1)     	Verbose help level 1 (shows parsing)\n");
printf("  8:    ?2 (?2)     	Verbose help level 2 (command descriptions)\n");
printf("  9:    ?F (?F)     	Print function list\n");
printf(" 10:     [ ([)     	Memory shortname, [mem_name\n");
printf(" 11:  base (B)     	Base for numeric display\n");
printf(" 12:   bin (BI)     	Binary format\n");
printf(" 13:   c2f (C2F)     	Celcius to Farenheit, x=x*9/5+32\n");
printf(" 14:   c2z (C2Z)     	Capacitance to impedance (memory w)\n");
printf(" 15:    ca (CA)     	Clear all, clears stack and memory\n");
printf(" 16:   chs (CH)     	Change sign, x=-x\n");
printf(" 17:  cmem (CM)     	Clear memory\n");
printf(" 18:  conj (CO)     	Complex conjucate, x=conj(x)\n");
printf(" 19:   cos (COS)     	Cosine, x=cos(x)\n");
printf(" 20:    cs (CS)     	Clear stack\n");
printf(" 21:    cx (CX)     	Clear x\n");
printf(" 22:     d (D)     	Degree mode\n");
printf(" 23:   d2v (D2V)     	dbm to voltage (memory R or default 50 ohms)\n");
printf(" 24:   d2w (D2W)     	dBm to watts, x=10^(x/10)*0.001\n");
printf(" 25:    db (DB)     	dB, y=10*log10(y/x), pop stack\n");
printf(" 26:   dbv (DBV)     	y=20*log10(y/x), pop stack\n");
printf(" 27:   dec (DE)     	Decimal format\n");
printf(" 28:   exp (E)     	x=exp(x)\n");
printf(" 29:   f2c (F2C)     	Farenheit to Celcius, x=(x-32)*5/9\n");
printf(" 30:   f2w (F2W)     	Hertz to radians, x=x*2pi\n");
printf("\nHit Return for more.");
fgets(buf,20,stdin);
  printf("\n  Function Shorthand    Description\n");

printf(" 31:   fix (FI)     	Fix print precision, fixN (N=0-15)\n");
printf(" 32:    fr (FR)     	frN: set frequency, w=2pi*N, saved in memory w\n");
printf(" 33:  frac (FRA)     	Fractional part of complex number\n");
printf(" 34:  help (H)     	Help\n");
printf(" 35:   hex (HE)     	Hexadecimal format\n");
printf(" 36:  imag (I)     	Imaginary part of complex number\n");
printf(" 37:   int (IN)     	Integer part of complex number\n");
printf(" 38:   inv (INV)     	Inverse, x=1/x\n");
printf(" 39:   l2z (L2Z)     	Inductance to impedance (memory w)\n");
printf(" 40:    ln (LN)     	Natural logrithm, x=ln(x)\n");
printf(" 41:   log (LO)     	Logrithm, y=log(y) base x, pop stack\n");
printf(" 42: log10 (LOG10)     	Log base 10, x=log10(x)\n");
printf(" 43:    m< (M<)     	Load memory from a file, m<filename\n");
printf(" 44:    m> (M>)     	Write memory to a file, m>filename\n");
printf(" 45:   mag (MA)     	Magnitude, x=mag(x)\n");
printf(" 46:   mem (ME)     	Show memory\n");
printf(" 47:   oct (O)     	Octal format\n");
printf(" 48:   p2r (P2R)     	Peak to rms, x=x/sqrt(2)\n");
printf(" 49:   par (PA)     	Parallel impedances, y=1/(1/x+1/y), pop\n");
printf(" 50:    pi (PI)     	Pi, push, enter pi into x\n");
printf(" 51:   pop (PO)     	Pop stack\n");
printf(" 52: print (PR)     	Print stack\n");
printf(" 53:  push (PU)     	Push stack\n");
printf(" 54:     q (Q)     	Quit\n");
printf(" 55:     r (R)     	Radian mode\n");
printf(" 56:   r2p (R2P)     	Rms to peak, x=x*sqrt(2)\n");
printf(" 57:  real (RE)     	Real part of complex number\n");
printf(" 58:   res (RES)     	Resonant impedance (memory w)\n");
printf(" 59:    rm (RM)     	Recall memory, rmN where N is an alphanumeric name\n");
printf(" 60:   s2p (S2P)     	Series impedance to parallel, push, y=Rp, x=jXp\n");
printf("\nHit Return for more.");
fgets(buf,20,stdin);
  printf("\n  Function Shorthand    Description\n");

printf(" 61:   s2z (S2Z)     	s11 to impedance (memory Z0 or default 50 ohms)\n");
printf(" 62:   sci (SC)     	Print format, toggles between float and scientific format\n");
printf(" 63:   sin (SI)     	Sine, x=sin(x)\n");
printf(" 64:    sm (SM)     	save to memory, smN where N is an alphanumeric name\n");
printf(" 65:  sqrt (SQ)     	Square root, x=sqrt(x)\n");
printf(" 66:  swap (SW)     	Swap x and y on stack\n");
printf(" 67:   tan (T)     	Tangent, x=tan(x)\n");
printf(" 68:     u (U)     	Undo, recall last stack (doesn't restore memory)\n");
printf(" 69:   v2d (V2D)     	Voltage to dbm (memory R or default 50 ohms)\n");
printf(" 70:   v2w (V2W)     	Voltage to watts (memory R or default 50 ohms)\n");
printf(" 71:   ver (VE)     	Print program version\n");
printf(" 72:   w2d (W2D)     	Watts to dBm, x=10log10(x/0.001)\n");
printf(" 73:   w2f (W2F)     	Radians to Hertz, x = x/(2pi)\n");
printf(" 74:   w2v (W2V)     	Watts to voltage (memory R or default 50 ohms)\n");
printf(" 75:   x^2 (X^2)     	x = x^2\n");
printf(" 76:   y^x (Y)     	y=y^x, pop stack\n");
printf(" 77:   z2c (Z2C)     	Impedance to capacitance (memory w)\n");
printf(" 78:   z2l (Z2L)     	Impedance to inductance (memory w)\n");
printf(" 79:   z2s (Z2S)     	Impedance to s11 (memory Z0 or default 50 ohms)\n");
}
